{% macro _render_errors(errors) -%}
    <ul>
        {%- for error in errors -%}
            <li>{{ error }}</li>
        {%- endfor -%}
    </ul>
{%- endmacro %}

{% macro form_header(form, method='post', action='', orientation='horizontal', id=none, classes='', multipart=False, i_form=true) -%}
    <form method="{{ method }}" {%- if action %} action="{{ action }}"{% endif %} class="{% if i_form %}i-form {% endif %}{{ orientation }} {{ classes }}"{% if id %} id="{{ id }}"{% endif %}{% if multipart %} enctype="multipart/form-data"{% endif %}>
        {% if form.csrf_enabled -%}
            {{ form.csrf_token() }}
        {% endif %}
{%- endmacro %}

{% macro form_row_static(label='', content=none, single_row=true) -%}
    <div class="form-group">
        <div class="form-label form-block {%- if single_row %} form-label-middle{% endif %}">
            {% if label %}
                <label>{{ label }}</label>
            {% endif %}
        </div>
        <div class="form-field form-block">
            <div class="static-text">
                {{ content or caller() }}
            </div>
        </div>
    </div>
{%- endmacro %}

{% macro form_field(field, field_classes, widget_attrs={}) -%}
    <div class="{{ field_classes }}"{% if field.errors %} data-error="{{ _render_errors(field.errors) }}"{% endif %}>
        {{ _render_field(field, widget_attrs) }}
        {% if field.widget.input_type == 'checkbox' %}
            <div class="checkbox-label">{{ field.label() }}</div>
        {% endif %}
        {% if field.description %}
            <p class="form-field-description"><em>{{ field.description | safe }}</em></p>
        {% endif %}
    </div>
{%- endmacro %}

{% macro form_row(field, widget_attrs={}, orientation='', allow_missing=false, skip_label=false) %}
    {% if field or not allow_missing %}
        <div id="form-group-{{ field.id }}"
             class="form-group {{ orientation }}
                    {% if field.errors %}has-error{% endif %}
                    {% if field.flags.initially_hidden %}weak-hidden{% endif %}">
            {% if not skip_label %}
                <div class="form-label form-block{% if _is_single_line_field(field) %} form-label-middle{% endif %}
                            {%- if field.type == 'BooleanField' %} form-label-empty{% endif -%}">
                    {%- if field.widget.input_type != 'checkbox' -%}
                        {{ field.label() }}
                    {%- endif -%}
                    {%- if field.flags.required %}<i class="required" title="{% trans %}This field is required{% endtrans %}">*</i>{% endif -%}
                </div>
            {% endif %}
            {{ form_field(field, "form-field form-block", widget_attrs) }}
        </div>
    {% endif %}
{%- endmacro %}

{% macro form_rows(form, fields=none, skip=(), orientation='', skip_labels=false, widget_attrs={}) %}
    {% for field in _iter_form_fields(form, fields=fields, skip=skip) %}
        {{ form_row(field, widget_attrs.get(field.short_name, {}), orientation, skip_label=skip_labels) }}
    {% endfor %}
{% endmacro %}

{# `form` and `i_form` args are there in case we need them in the future #}
{% macro form_footer(form, i_form=true) -%}
    {% if caller %}
        <div class="form-group form-group-footer">
            <div class="form-label form-block"></div>
            <div class="form-field form-block">
                {{ caller() }}
            </div>
        </div>
    {% endif %}
    </form>
{% endmacro %}

{% macro form_fieldset(legend, description=none, disabled=false, render_as_fieldset=true) %}
    {% if not render_as_fieldset %}
        {#
        This is sugar for cases where you sometimes want the fieldset
        to show up as a fieldset and sometimes just want the contents.
        The most common use case for this is a form which has either
        a single fieldset or multiple fieldsets depending on the user's
        privileges. In this case it often looks better not to show the
        single fieldset as an actual fieldset.
        Using `render_as_fieldset` keep the code using this macro clean
        as it won't need extra conditions/macros/blocks to show the same
        content either inside or outside this fieldset.
        #}
        {{ caller() }}
    {% else %}
        <fieldset{% if disabled %} disabled {% endif %}>
            <legend>{{ legend }}</legend>
            {% if description %}
                <p class="description">{{ description }}</p>
            {% endif %}
            {{ caller() }}
        </fieldset>
    {% endif %}
{% endmacro %}
